from pygraph import PlainGraph, Graph

print("Using plain graph (string node labels, no edge labels)")

graph = PlainGraph()
n1 = graph.addNode("node1")
n2 = graph.addNode("node2")
n3 = graph.addNode("node3")

n1.addNeighbor(n2)
n2.addNeighbor(n3)
n3.addNeighbor(n1)
n1.addNeighbor(n1)

graph.walkDfs(
    lambda node: print(f"Pre: {node.data}"),
    lambda node: print(f"Post: {node.data}")
)

# Second part of the exercise - feel free to comment it out while working on the
# first part

print("Using a graph with Python objects")

graph = Graph()
n1 = graph.addNode({"key": "value"})
n2 = graph.addNode(42)
n3 = graph.addNode("node3")

n1.addNeighbor(n2, "Edge parameter 1")
n2.addNeighbor(n3, "Edge parameter 2")
n3.addNeighbor(n1, "Edge parameter 3")
n1.addNeighbor(n1, "Edge parameter 4")

graph.walkDfs(
    lambda node: print(f"Pre: {node.data}"),
    lambda node: print(f"Post: {node.data}")
)
